#import "ST_FIlter_Controller.h"
#import "spatio_Temporal_Filter.h"
#import "htView.h"
#import "DrawXYRF.h"
#import "gxView.h"
#import "DrawXYTRF.h"
#import "setRF.h"
#import "DrawXTRF.h"
#import "input_area.h"

@implementation ST_FIlter_Controller

- (void)awakeFromNib
{
	//initialize parameters and views
	[spatio_Temporal_Filter m_memory];
	[spatio_Temporal_Filter set_g_sigmax:[slider_sigmax doubleValue]
                                  sigmay:[slider_sigmay doubleValue]
                                  f:[slider_f doubleValue]
                                  sita:[slider_sita doubleValue]
                                  phase_g:[slider_phase_g doubleValue]
                                  fai_g:[slider_fai_g doubleValue]];
    [spatio_Temporal_Filter set_gabor];
    [spatio_Temporal_Filter set_st_filter];
    
	// Draw Images
    [gx_View set_sigmax: [slider_sigmax doubleValue]
                      f: [slider_f doubleValue]
                phase_g: [slider_phase_g doubleValue]
                  fai_g: [slider_fai_g doubleValue]];
    [ gx_View setNeedsDisplay:YES ];
	[spatio_Temporal_Filter set_xt_function];
	
    [drawXYRF setLeftImage: [spatio_Temporal_Filter gabor_1] ];
    [drawXYTRF setRightImage: [spatio_Temporal_Filter st_filter] 
                        time: [slider_time intValue] ];
	[drawXTRF setxtView:[spatio_Temporal_Filter xt_function] ];
	
	[spatio_Temporal_Filter set_h_tau    : [slider_tau doubleValue]
                                  omega  : [slider_omega doubleValue]
                                  phase_h: [slider_phase_h doubleValue]
                                  fai_h  : [slider_fai_h doubleValue] ];
    [spatio_Temporal_Filter set_ht];
    [spatio_Temporal_Filter set_st_filter];
    
	// Draw Images
    [ ht_View set_tau: [slider_tau doubleValue]        
                omega: [slider_omega doubleValue]      
              phase_h: [slider_phase_h doubleValue]    
                fai_h: [slider_fai_h doubleValue] ];
    [ ht_View setNeedsDisplay:YES ];
	[spatio_Temporal_Filter set_xt_function];
	
	[drawXYTRF setRightImage: [spatio_Temporal_Filter st_filter] 
                        time: [slider_time intValue] ];
	[drawXTRF setxtView:[spatio_Temporal_Filter xt_function] ];
	
	[inputArea set_input_area_sita:[slider_sita doubleValue]];
	[inputArea setNeedsDisplay:YES];
	
	
}

- (IBAction)change_g:(id)sender
{
	// Set parameters from slider value
    [spatio_Temporal_Filter set_g_sigmax:[slider_sigmax doubleValue]
                                  sigmay:[slider_sigmay doubleValue]
                                  f:[slider_f doubleValue]
                                  sita:[slider_sita doubleValue]
                                  phase_g:[slider_phase_g doubleValue]
                                  fai_g:[slider_fai_g doubleValue]];
    [spatio_Temporal_Filter set_gabor];
    [spatio_Temporal_Filter set_st_filter];
    
	// Draw Images
    [gx_View set_sigmax: [slider_sigmax doubleValue]
                      f: [slider_f doubleValue]
                phase_g: [slider_phase_g doubleValue]
                  fai_g: [slider_fai_g doubleValue]];
    [ gx_View setNeedsDisplay:YES ];
	[spatio_Temporal_Filter set_xt_function];
	
    [drawXYRF setLeftImage: [spatio_Temporal_Filter gabor_1] ];
    [drawXYTRF setRightImage: [spatio_Temporal_Filter st_filter] 
                        time: [slider_time intValue] ];
	[drawXTRF setxtView:[spatio_Temporal_Filter xt_function] ];
	
	[ text_sigmax setDoubleValue:[slider_sigmax doubleValue]*4.0 ];//ȇ傫̐ݒ
	[ text_sigmay setDoubleValue:[slider_sigmay doubleValue]*4.0 ];//ȇ傫̐ݒ
	[ text_sita setDoubleValue:[slider_sita doubleValue] ];
	[ text_f setDoubleValue:[slider_f doubleValue]*0.65/0.90 ];
	[ text_phase_g setDoubleValue:[slider_phase_g doubleValue] ];
	[ text_fai_g setDoubleValue:[slider_fai_g doubleValue] ];
	
	[inputArea set_input_area_sita:[slider_sita doubleValue]];
	[inputArea setNeedsDisplay:YES];
}


- (IBAction)change_h:(id)sender
{
	// Set parameters from slider value
    [spatio_Temporal_Filter set_h_tau    : [slider_tau doubleValue]
                                  omega  : [slider_omega doubleValue]
                                  phase_h: [slider_phase_h doubleValue]
                                  fai_h  : [slider_fai_h doubleValue] ];
    [spatio_Temporal_Filter set_ht];
    [spatio_Temporal_Filter set_st_filter];
    
	// Draw Images
    [ ht_View set_tau: [slider_tau doubleValue]        
                omega: [slider_omega doubleValue]      
              phase_h: [slider_phase_h doubleValue]    
                fai_h: [slider_fai_h doubleValue] ];
    [ ht_View setNeedsDisplay:YES ];
	[spatio_Temporal_Filter set_xt_function];
	
	[drawXYTRF setRightImage: [spatio_Temporal_Filter st_filter] 
                        time: [slider_time intValue] ];
	[drawXTRF setxtView:[spatio_Temporal_Filter xt_function] ];
	
	[ text_tau setDoubleValue:[slider_tau doubleValue]*0.005 ];//т̃W̐ݒ
	[ text_omega setDoubleValue:[slider_omega doubleValue] ];
	[ text_phase_h setDoubleValue:[slider_phase_h doubleValue] ];
	[ text_fai_h setDoubleValue:[slider_fai_h doubleValue] ];
}

/*- (IBAction)change_sigmax:(id)sender
{
	[slider_sigmax setDoubleValue:[text_sigmay doubleValue]/5.0 ];
}*/

/*- (IBAction)change_sigmay:(id)sender
{
	[slider_sigmay setDoubleValue:[text_sigmay doubleValue]/5.0 ];
}*/

- (IBAction)change_D_selectivity:(id)sender
{
    [spatio_Temporal_Filter set_type:[[sender selectedCell] tag]];
    [spatio_Temporal_Filter set_st_filter];
	[spatio_Temporal_Filter set_xt_function];
	
	[drawXYTRF setRightImage: [spatio_Temporal_Filter st_filter] 
                        time: [slider_time intValue] ];
	[drawXTRF setxtView:[spatio_Temporal_Filter xt_function] ];
}

- (IBAction)change_time:(id)sender
{
    [drawXYTRF setRightImage:[spatio_Temporal_Filter st_filter]
                        time:[sender intValue] ];
}

- (IBAction)setRF_clicked:(id)sender
{
     [ setRF openData];
}


- (IBAction)change_time2:(id)sender
{
    [setRF setImage_time:[sender intValue] ];
}

- (IBAction)setButton_clicked:(id)sender
{
	[ setRF set_RFarray:[spatio_Temporal_Filter st_filter] ];
	[ setRF setbuttonxtView:[spatio_Temporal_Filter st_filter] ];
}

@end
