/* Spatio_Temporal_Filter */

#import <Cocoa/Cocoa.h>

#define RF_width 20
#define RF_height 20
#define RF_time 21

@interface Spatio_Temporal_Filter : NSObject
{
    double sigmax, sigmay, f, sita, phase_g, fai_g;
    double tau, omega, phase_h, fai_h;
    
    double **gabor_1;
    double **gabor_2;
    double ht_1[RF_time], ht_2[RF_time];
    double ***st_filter;
	double **xt_function;
	double gx_array1[RF_width], gx_array2[RF_width];
    
    int type;
}

- (void)set_g_sigmax:(double)sigmax1 sigmay:(double)sigmay1 f:(double)f1 sita:(double)sita1 phase_g:(double)phase_g1 fai_g:(double)fai_g1;
- (void)set_h_tau:(double)tau1 omega:(double)omega1 phase_h:(double)phase_h1 fai_h:(double)fai_h1;
- (void)set_type:(int)value;
- (void)set_gabor;
- (void)set_ht;
- (void)set_st_filter;
- (void)set_xt_function;

- (double **)gabor_1;
- (double **)gabor_2;
- (double ***)st_filter;
- (double **)xt_function;

- (double)sigmax;
- (double)sigmay;
- (double)f;
- (double)sita;
- (double)phase_g;
- (double)fai_g;
- (double)tau;
- (double)omega;
- (double)phase_h;
- (double)fai_h;


- (void)m_memory;

@end
