#import "Spatio_Temporal_Filter.h"

@implementation Spatio_Temporal_Filter

- (void)m_memory
{
    int i, j;
    
	// reservation memory
    gabor_1 = malloc(sizeof(double *)*RF_width);
    gabor_2 = malloc(sizeof(double *)*RF_width);
    st_filter = malloc(sizeof(double **)*RF_time);
	xt_function = malloc(sizeof(double *)*RF_width);
    for(i=0; i<RF_time; i++){
        *(st_filter+i) = malloc(sizeof(double *)*RF_width);
        for(j=0; j<RF_width; j++){
            *(*(st_filter+i)+j) = malloc(sizeof(double)*RF_height);
        }
    }
    
    for(i=0; i<RF_width; i++){
        *(gabor_1+i) = malloc(sizeof(double)*RF_height);
        *(gabor_2+i) = malloc(sizeof(double)*RF_height);
		*(xt_function+i) = malloc(sizeof(double)*RF_time);
    }
	
	// initialize "type" parameter
	// this equals NSPopUpBottoun start value
    type=3;
	
}

// p[^iCX^Xϐj̃Zbg
- (void)set_g_sigmax:(double)sigmax1 sigmay:(double)sigmay1 f:(double)f1 sita:(double)sita1 phase_g:(double)phase_g1 fai_g:(double)fai_g1
{
    sigmax = sigmax1;
    sigmay = sigmay1;
    f = f1;
    sita = sita1;
    phase_g = phase_g1;
    fai_g = fai_g1;
}

- (void)set_h_tau:(double)tau1 omega:(double)omega1 phase_h:(double)phase_h1 fai_h:(double)fai_h1
{
    tau = 0.005*tau1;  //taũWA0.05`0.25ɂ
    omega = omega1; 
    phase_h = phase_h1;
    fai_h = fai_h1;
}

- (void)set_type:(int)value
{
    type = value;
}

// ez̃Zbg
- (void)set_gabor
{
	// XP[Oɂ
	// x, yɂẮA0.0 ~ } (RF_width or RF_height)*amp_xy/2.0 ɂȂ
	double amp_xy = 0.1;
    int X, Y;
    double x, y, X1, Y1;
	//double gabor_1_max=0.0;
	//double gabor_2_max=0.0;
	//double gx_array_1max=0.0;
	//double gx_array_2max=0.0;
    
    for (Y=0; Y<RF_height; Y++){
        for (X=0; X<RF_width; X++){
            
            X1 = amp_xy*(-RF_width/2.0+X); 
            Y1 = amp_xy*(-RF_height/2.0+Y);
            
            x = cos(2*3.1415*sita/360.0)*X1 - sin(2*3.1415*sita/360.0)*Y1;
            y = sin(2*3.1415*sita/360.0)*X1 + cos(2*3.1415*sita/360.0)*Y1;
            
            *(*(gabor_1+X)+Y) = pow(2.71828,-2.0*(x*x/sigmax/sigmax+y*y/sigmay/sigmay))*cos(2*3.1415*(f*x+phase_g/360.0));
            *(*(gabor_2+X)+Y) = pow(2.71828,-2.0*(x*x/sigmax/sigmax+y*y/sigmay/sigmay))*cos(2*3.1415*(f*x+(phase_g+fai_g)/360.0));
			
			/*if (*(*(gabor_1+X)+Y) >gabor_1_max){
					gabor_1_max = *(*(gabor_1+X)+Y);
				}
				if (*(*(gabor_2+X)+Y) > gabor_2_max){
					gabor_2_max = *(*(gabor_2+X)+Y);
				}*/
        }
	}	
	/**********************************
	gabor_1, gabor_2KB
	***********************************/
	/*for (Y=0; Y<RF_height; Y++){
		for (X=0; X<RF_width; X++){
			*(*(gabor_1+X)+Y) = (*(*(gabor_1+X)+Y))/gabor_1_max;
			*(*(gabor_2+X)+Y) = (*(*(gabor_1+X)+Y))/gabor_2_max;
		}
	}*/
		
	for (X=0; X<RF_width; X++){
		x = amp_xy*(-RF_width/2.0+X);
		
		gx_array1[X] = pow(2.71828,-2.0*(x*x/sigmax/sigmax))*cos(2*3.1415*(f*x+phase_g/360.0));
		gx_array2[X] = pow(2.71828,-2.0*(x*x/sigmax/sigmax))*cos(2*3.1415*(f*x+(phase_g+fai_g)/360.0));
	}
	
	/***********************************
	gx_array1, gx_array2K
	***********************************/
	/*for (X=0; X<RF_width; X++){
		if (gx_array1[X] > gx_array_1max){
			gx_array_1max = gx_array1[X];
		}
		if (gx_array2[X] > gx_array_2max){
			gx_array_2max = gx_array2[X];
		}
	}
	for (X=0; X<RF_width; X++){
		gx_array1[X] = gx_array1[X]/gx_array_1max;
		gx_array2[X] = gx_array2[X]/gx_array_2max;
	}*/
}

- (void)set_ht
{
	double amp_t =0.03; //t͈̔͂XP[O
    int t;
	//double ht_1max = 0.0;
	//double ht_2max = 0.0;
    
    for (t=0; t<RF_time; t++){
        ht_1[t] = (amp_t*t/tau/tau)*pow(2.71828,-(amp_t*t/tau))*cos(omega*amp_t*t+3.141592*phase_h/180.0);
        ht_2[t] = (amp_t*t/tau/tau)*pow(2.71828,-(amp_t*t/tau))*cos(omega*amp_t*t+3.141592*(phase_h+fai_h)/180.0);
		
		/*******************
		htmaxlƂĂB
		*********************/

		/*if (ht_1[t] > ht_1max){
			ht_1max = ht_1[t];
		}
		if (ht_2[t] > ht_2max){
			ht_2max = ht_2[t];
		}*/
    }
	/***************************
	htK
	****************************/
	/*for (t=0; t<RF_time; t++){
		ht_1[t] = ht_1[t]/ht_1max;
		ht_2[t] = ht_2[t]/ht_2max;
	}*/
}

- (void)set_st_filter
{            
    int x, y, t;
	double st_filter_max=0.000000001;
	
    switch (type){
        case 1:   // g1*h1-g2*h2
            for (t=0; t<RF_time; t++){
                for (y=0; y<RF_height; y++){
                    for (x=0; x<RF_width; x++){
                        *(*(*(st_filter+(RF_time-1-t))+x)+y) = (*(*(gabor_1+x)+y)*ht_1[t] - *(*(gabor_2+x)+y)*ht_2[t]);
                    }
                }
            }
            break;
            
        case 2:  // g1*h2+g2*h1

            for (t=0; t<RF_time; t++){
                for (y=0; y<RF_height; y++){
                    for (x=0; x<RF_width; x++){
                        *(*(*(st_filter+(RF_time-1-t))+x)+y) = (*(*(gabor_1+x)+y)*ht_2[t] + *(*(gabor_2+x)+y)*ht_1[t]);
                    }
                }
            }
			break;
        
        case 3:   // g1*h1+g2*h2

            for (t=0; t<RF_time; t++){
                for (y=0; y<RF_height; y++){
                    for (x=0; x<RF_width; x++){
                        *(*(*(st_filter+(RF_time-1-t))+x)+y) = (*(*(gabor_1+x)+y)*ht_1[t] + *(*(gabor_2+x)+y)*ht_2[t]);
                    }
                }
            }
			break;
        
        case 4:   //g1*h2-g2*h1

            for (t=0; t<RF_time; t++){
                for (y=0; y<RF_height; y++){
                    for (x=0; x<RF_width; x++){
                        *(*(*(st_filter+(RF_time-1-t))+x)+y) = (*(*(gabor_1+x)+y)*ht_2[t] - *(*(gabor_2+x)+y)*ht_1[t]);
                    }
                }
            }
			break;
	}
	
	/**********************************************************
	st_filterKB
	***********************************************************/
	
	for (t=0; t<RF_time; t++){
		for (y=0; y<RF_height; y++){
			for (x=0; x<RF_width; x++){
				if ( *(*(*(st_filter+(RF_time-1-t))+x)+y) > st_filter_max){
					st_filter_max = *(*(*(st_filter+(RF_time-1-t))+x)+y);
				}
			}
		}
	}
	for (t=0; t<RF_time; t++){
		for (y=0; y<RF_height; y++){
			for (x=0; x<RF_width; x++){
				*(*(*(st_filter+(RF_time-1-t))+x)+y) = (*(*(*(st_filter+(RF_time-1-t))+x)+y))/st_filter_max;
			}
		}
	}
}

- (void)set_xt_function
{
	int x, t;
	double xt_f_max=0.0;
	
    switch (type){
        case 1:   // g1*h1-g2*h2
			
			for (t=0; t<RF_time; t++){
				for (x=0; x<RF_width; x++){
					*(*(xt_function+x)+t) = (gx_array1[x]*ht_1[t] - gx_array2[x]*ht_2[t]);
					
					//fprintf(stderr,"%f \n",*(*(xt_function+x)+t));
				}
			}
			break;
		
		case 2:   // g1*h2+g2*h1
			
			for (t=0; t<RF_time; t++){
				for (x=0; x<RF_width; x++){
					*(*(xt_function+x)+t) = (gx_array1[x]*ht_2[t] + gx_array2[x]*ht_1[t]);
				}
			}
			break;
			
		case 3:   // g1*h1+g2*h2
			
			for (t=0; t<RF_time; t++){
				for (x=0; x<RF_width; x++){
					*(*(xt_function+x)+t) = (gx_array1[x]*ht_1[t] + gx_array2[x]*ht_2[t]);
				}
			}
			break;
			
		case 4:   // g1*h2-g2*h1
			
			for (t=0; t<RF_time; t++){
				for (x=0; x<RF_width; x++){
					*(*(xt_function+x)+t) = (gx_array1[x]*ht_2[t] - gx_array2[x]*ht_1[t]);
				}
			}
			break;
	}
	
	/********************************
	xt_fuctionK
	*********************************/
	for (t=0; t<RF_time; t++){
		for (x=0; x<RF_width; x++){
			if ((*(*(xt_function+x)+t)) > xt_f_max){
				xt_f_max = *(*(xt_function+x)+t);
			}
		}
	}
	for (t=0; t<RF_time; t++){
		for (x=0; x<RF_time; x++){
			*(*(xt_function+x)+t) = (*(*(xt_function+x)+t))/xt_f_max;
		}
	}
}



// 艺̓ANZbT\bhiCX^XϐONXɓn\bhj
// \bh̓CX^XϐƓ

- (double **)gabor_1
{
    return gabor_1;
}

- (double **)gabor_2
{
    return gabor_2;
}

- (double ***)st_filter
{
    return st_filter;
}

- (double **)xt_function
{
	return xt_function;
}

- (double)sigmax
{
    return sigmax;
}

- (double)sigmay
{
    return sigmay;
}

- (double)f
{
    return f;
}

- (double)sita
{
    return sita;
}

- (double)phase_g
{
    return phase_g;
}

- (double)fai_g
{
    return fai_g;
}

- (double)tau
{
    return tau;
}

- (double)omega
{
    return omega;
}

- (double)phase_h
{
    return phase_h;
}

- (double)fai_h
{
    return fai_h;
}

@end
