//
// Spikewave - this class implements a spike train generator
// 2001-12-27  Izumi Ohzawa, ohzawa@bpe.es.osaka-u.ac.jp
// 
// -------- Modified from the following ------------------
//
// a very simple Cocoa CoreAudio app
// by James McCartney  james@audiosynth.com  www.audiosynth.com
//
// Spikewave - this class implements a spike oscillator with dezippered control of frequency, pan and amplitude
//

#import <Cocoa/Cocoa.h>
#include <CoreAudio/AudioHardware.h>

@interface Spikewave : NSObject
{
        double freq, pan, amp;		// controls
        double phase;			// oscillator phase in radians
        
        long cnt;
	Boolean		initialized;	// successful init?
	Boolean		soundPlaying;	// playing now?
	AudioDeviceID	device;		// the default device
	UInt32	deviceBufferSize;	// bufferSize returned by kAudioDevicePropertyBufferSize
        AudioStreamBasicDescription	deviceFormat;	// info about the default device
}

- (void)setup;
- (BOOL)start;
- (BOOL)sstop;

- (void)setAmpVal:(double)val;
- (void)setFreqVal:(double)val;
- (void)setPanVal:(double)val;
@end
